; application subwindow hit routine for wined
; v. 1.07      2016 Jul 04 use dev8_ keys
; v. 1.06      2003 Jun 04 08:40:30
;  w. lenerz 1994-2016

; nb in the appsub wdw, the mouse pointer has the shape of a cursor.


	section app_hit

	include dev1_asm_wined_includes
	include dev8_keys_k
	include dev8_keys_wwork

	xdef	set_app
	xdef	app_hit
	xdef	set_cur
	xref	get_alpha		; routine for ascii
	xref	colw			; app sub win colour byte (wined_cfg_asm)

; on entry, a0 = channel id of window
; the window must be set to the appsub window
appregs reg	d1/d5-d7/a0/a5

app_out2
	bsr	cur_disbl		; disable cursor
	bsr.s	set_cur 		; set cursor
pp_out2 movem.l (a7)+,appregs
ap_out	moveq	#-1,d3
	moveq	#0,d0
	rts

set_cur bsr	calcur			; calculate pointer position according...
	mulu	#6,d1			; ... to cursor pos
	mulu	#10,d2
	swap	d1
	add.l	d2,d1
	add.l	#app_origs,d1		; make relative to entire window
	add.l	#$60006,d1		; pointer origin
	moveq	#1,d2
setcur2 moveq	#$7b,d0 		; set pointer.
	trap	#3
	rts

; this is the app sub wdw hit/do/ptr move routine

app_hit cmp.b	#k.hit,d2		; is it a hit?
	beq.s	do_app			; yes ->...
	cmp.b	#k.do,d2		; is it a do?
	beq.s	do_app			; yes ->...
	cmp.b	#9,d2			; is it a tab?
	bne	crsr_snap		; no, snap cursor to char position ->...
; tab
	swap	d1			; here it is a tab, so set new x position
	moveq	#0,d2
	move.w	$e(a1),d2		; x pointer position
	sub.w	#leftpix,d2		; don't do anything if too far to the left
	blt	ap_out
	sub.w	#charpix-leftpix,d2	; are we in hex or in char field?
	blt.s	inhex			; in hex->...

inchar	mulu	#3,d2			; this corresponds to the char position
	add.w	#leftpix,d2		; + offset from window left border
ptrcom	add.w	$1c(a1),d2		; + x window border position
	move.w	d2,d1			; makes new pointer x position
	swap	d1			; reset to x | y
	moveq	#-1,d3			; set cursor now
	moveq	#0,d2			; key
	bra.s	setcur2 		; do it!

inhex	add.w	#charpix-leftpix,d2 ; same as above
	divs	#3,d2
	add.w	#charpix,d2
	bra.s	ptrcom


; here there was a hit or a do in the appsub window
; on entry:
; d1 = x pos | y pos of pointer
; d6: if bit 0 set, we are in low nibble of hex byte
; d6: if bit 1 set, we are in char field
do_app	movem.l appregs,-(a7)
	sub.l	ww_xorg(a4),d1		; make pointer position relative
	sub.l	#app_origs,d1		; ... now
	moveq	#0,d2
	move.w	d1,d2			; d2 = y position
	divu	#10,d2			; in character coords now
	cmp.w	nr_rows(a4),d2		; don't exceed the number of rows in window
	ble.s	ok_y
	move.w	nr_rows(a4),d2
ok_y	swap	d1			; x position in lower word
	ext.l	d1			; make upper word 0
	divu	#6,d1			; d1 = x position in char coords
	ext.l	d1			;
	subq.w	#leftbord,d1		; this is the left border
	blt	pp_out2 		; we mustn't overshoot that!
	addq.w	#leftbord,d1		; + offset from left border
	moveq	#0,d5			; initialise
	moveq	#0,d6			;     "     : hex field and in upper nibble
see_what
	sub.w	#charbord,d1		; are we in hex or in char field?
	blt.s	is_hex
is_char bset	#1,d6			; show that we are in char field
	bra.s	curs_all		; and go to it->...
is_hex	add.w	#charbord-leftbord,d1 ; we are in hex field
	move.l	d1,d4			;
	divu	#3,d4			; 2 figures + 1 space per char, so if
	swap	d4			; remainder of div=2, we are on space
	cmp.w	#2,d4			; are we on a space by any chance?
	bne.s	no_space	; no ->...
	add.w	#leftbord+1,d1	; left border
	bra.s	see_what
no_space
	tst.w	d4		; are we in high or low nibble?
	bne.s	lownib
	bset	#0,d6		; show that we are in low nibble
lownib	swap	d4
	move.w	d4,d1		; char in row

; in here, d5 is the number of the char displayed in the window
curs_all
	lsl.w	#4,d2		; d2 = number of row * chars in row
	add.w	d2,d1
	move.l	d1,d5		; d5 = number of char
	moveq	#-1,d3
	bsr	set_app 	; set window to appsub window
	bsr	over0		; set over mode in window to 0
	bsr	cur_enbl	; enable cursor now
get_choice
	bsr	set_crsr	; set cursor now
	bsr	get_byte	; get one byte
	cmpi.b	#esc,d1 	; do we leave editing mode ?
	beq	app_out2	; yes ->...
	move.b	d1,d4		; keep byte for later
	cmpi.b	#up,d4		; was up?
	bne.s	not_up		; no->...
	subi.w	#$10,d5 	; yes, so new char in row
	bra.s	wrap		; display->...
not_up	cmpi.b	#down,d4	; was it down?
	bne.s	not_down	; no->...
	addi.w	#$10,d5 	; yes, so new char (each row has $10 chars)
wrap	move.w	nr_rows(a4),d0	; number of rows
	rol.w	#4,d0		; make sure that d5 doesn't exceed..
	add.b	#$f,d0		; ..the max number of rows, nor the..
	and.w	d0,d5		; min number of rows (wraps cursor)
	bra.s	get_choice

not_down
	cmpi.b	#left,d4	; did we go left?
	bne.s	not_left	; no->...
	tst.b	d6		; yes, do the stuff
	bne.s	ndown1
	bset	#0,d6
	bra.s	get_choice
ndown1	bclr	#$00,d6
	subq.w	#$01,d5
	bra.s	wrap
not_left
	cmpi.b	#right,d4	; did we go right?
	bne.s	not_right	; no->...
	btst	#0,d6
	beq.s	nextchar
	btst	#1,d6
	bne.s	nextchar
	bclr	#0,d6
	bra.s	get_choice
nextchar
	bset	#0,d6
	addq.w	#1,d5
	bra.s	wrap

not_right
	cmpi.b	#tab,d4 		; did we use tab?
	bne.s	not_tab 		; no->...
	bchg	#1,d6
	bset	#0,d6
	bra.s	get_choice
not_tab bsr	get_alpha		; get chars
	bra	get_choice		; and do it again


trapregs reg	d1-d3/a1		; these are used in several routines!

;----------------------------------------
; this sets the cursor according to d6 & d5
; d6: bit 1 set if we are in char field
; d6 : bit 0 set if we are in high nibble
;----------------------------------------

set_crsr
	movem.l trapregs,-(a7)
	bsr.s	calcur
	moveq	#$10,d0
	bra.s	trap3

;----------------------------------------
; this calculates the cursor position according to d6 & d5
; d6: bit 1 set if we are in char field
; d6 : bit 0 set if we are in high nibble
;----------------------------------------

calcur	move.l	d5,d2
	move.l	d5,d1
	lsr.w	#4,d2
	divu	#16,d1
	swap	d1			; x position
	btst	#$01,d6 		; are we in hex window?
	beq.s	in_hex			; yes ->...
	addi.w	#charbord,d1
all_curs
	rts
in_hex	mulu	#3,d1
	addq.w	#$08,d1 		; calculate x position
	btst	#0,d6			; high or low nibble?
	beq.s	all_curs
	subq.w	#1,d1			; if high...
	bra.s	all_curs

;----------------------------------------
; this enables the cursor
; all regs preserved. condition codes set
;----------------------------------------
cur_enbl
	moveq	#$e,d0
	bra.s	tt

;----------------------------------------
; this disables the cursor
; all regs preserved. condition codes set
;----------------------------------------
cur_disbl
	moveq #$f,d0
tt	movem.l trapregs,-(a7)
trap3	trap	#3
	movem.l (a7)+,trapregs
	tst.l	d0
	rts
;----------------------------------------
; this sets overwrite mode to 0
; all regs preserved. condition codes set
;----------------------------------------

over0	movem.l trapregs,-(a7)
	moveq	#0,d1
	moveq	#$2c,d0
	bra.s	trap3

;----------------------------------------
; this sets the window to the appsub window
; all regs preserved. condition codes set
;----------------------------------------

set_app movem.l trapregs,-(a7)
	moveq	#-1,d2
	moveq	#0,d1
	jsr	$60(a5) 		; set window to appsub window
	tst.l	d0
	bne.s	s_a_err
	lea	colw(pc),a1
	cmp.b	#4,(a1)
	blt.s	old_col
	move.w	paper(a4),d1
	moveq	#$27,d0
	moveq	#-1,d3
	jsr	$84(a5) 		; set paper colour
	move.w	paper(a4),d1
	moveq	#$28,d0
	jsr	$84(a5) 		; set strip colour
	move.w	ink(a4),d1		; this is the ink col
	moveq	#$29,d0
	jsr	$84(a5) 		; set ink col
	bra.s	s_a_err
old_col
	move.w	paper(a4),d1
	moveq	#$27,d0
	moveq	#-1,d3
	trap	#3		; set paper colour
	move.w	paper(a4),d1
	moveq	#$28,d0
	trap	#3		; set strip colour
	move.w	ink(a4),d1	     ; this is the ink col
	moveq	#$29,d0
	trap	#3
s_a_err movem.l (a7)+,trapregs
	tst.l	d0
	rts


;----------------------------------------
; this gets one byte from the channel
; d1 contains bytes on return
; all regs preserved. condition codes set
;----------------------------------------
get_byte
	move.l	a1,-(a7)
	moveq	#1,d0
	trap	#3
	move.l	(a7)+,a1
	tst.l	d0
	rts


; this snaps cursor to position
	
crsr_snap tst.w $c(a1)
	bne	ap_out
	cmp.l	ptrpos(a4),d1
	beq	ap_out
	move.l	d1,ptrpos(a4)
	move.b	$17(a1),d1
	btst	#3,d1		; pointer moved?
	beq	ap_out		; no, so leave
	addq.l	#8,a1
	moveq	#3,d3
loop	move.l	d1,ptrpos(a4)
	moveq	#1,d2
	moveq	#$71,d0
	trap	#3		; read short pointer
	cmp.l	(a1),a0 	; is it still our channel?
	bne	ap_out		; no ->...
	cmp.l	ptrpos(a4),d1
	bne.s	loop
	moveq	#0,d0
	move.w	6(a1),d0
	divs	#6,d0
	moveq	#0,d1
	move.w	d0,d1
	mulu	#6,d1
	moveq	#0,d0
	move.w	8(a1),d0	; y coordinate in window
	divs	#10,d0		; in char coordinates now
	moveq	#0,d2
	move.w	d0,d2
	mulu	#10,d2
	swap	d1
	move.w	d2,d1		; d1 = x, y pointer pos in window
	add.l	$14(a1),d1	; absolute coords now
	add.l	#$00030005,d1	; cursor origins
	cmp.l	ptrpos(a4),d1
	beq	ap_out
	move.l	d1,ptrpos(a4)
	moveq	#+1,d3
	moveq	#0,d2
	moveq	#$7b,d0
	trap	#3
	bra	ap_out




	end
