; get_alpha for WINED
; v. 1.01	1995 Sep 19 14:05:39
;  W. Lenerz 1994 - 2018


; get bytes into editor window, either in ascii
; window or in hex window
; D6: BIT 0 SET: we are on low nibble
; D6 bit 1 set: we are in hex window
; D5 =	cursor position in file

	section get_alpha

	xdef	get_alpha

	xref	gu_upper
	xref	make1to9



	include dev1_asm_wined_includes

; this gets normal byte:


get_alpha moveq #0,d7		; initialise
	btst	#$01,d6 	; are we in ascii window?
	bne.s	chge_byte	; yes ->...
; here we are in the hex window
in_hex	move.b	d4,d1		; d1 = char
	bsr	gu_upper	; into upper case
	cmpi.b	#'0',d1
	blt	nct_out
	cmpi.b	#'9',d1
	ble.s	do_hex
	cmpi.b	#'A',d1
	blt	nct_out
	cmpi.b	#'F',d1 	; make sure it is a hex byte
	bgt	nct_out
do_hex	move.b	d1,d4
	bsr	make1to9		; d1 is made into true byte
	move.b	d1,d4
	moveq	#0,d0		; initialise d0
	move.w	row(a4),d0	; "row", i.e. 256 byte chunk
	lsl.w	#8,d0		; *256...
	cmp.w	#$1f,nr_rows(a4)
	bne.s	small_win
	lsl.w	#1,d0		; if large window: 512 chunks
small_win add.w d5,d0		; ...plus position, plus...
	add.l	#file_sp,d0	; start of area= point to this byte now
	move.b	(a4,d0.l),d1	; d1 = byte to change
	btst	#$00,d6 	; high or low nibble?
	beq.s	high		; high->...
	andi.b	#$0f,d1 	; get rid of high nibble
	lsl.b	#$04,d4 	; move into high nibble
	moveq	#1,d7		; set flag
	bra.s	both
high	andi.b	#$f0,d1 	; get rid of low nibble
both	add.b	d1,d4		; make into entire byte in d4
	bchg	#0,d6		; show that we must go to other nibble
	bra.s	cb02

; here we are in the alpha window
chge_byte moveq #0,d0
	move.w	row(a4),d0	; first or second half ?
	lsl.w	#8,d0		; * 256
	add.w	d5,d0		; add position
	add.l	#file_sp,d0
cb02	move.b	d4,(a4,d0.l)	; change this byte now
	moveq	#0,d1
	move.w	d5,d1		; d1 = position in display
	divu	#16,d1		; determine row:
				; d1.h = remainder, d1.l=row
	move.w	d1,d2		; row number now
	swap	d1		; offset into row now
	move.w	d1,-(a7)	; keep offset in row
	mulu	#3,d1		; *3, each byte takes 3 chars in the hex window
	addq.w	#7,d1		; offset
	moveq	#-1,d3
	moveq	#$10,d0
	trap	#3		; set cursor position to hex window
	swap	d7
	move.b	d4,d7
	move.b	d7,d1
	bsr.s	print_2_nbrs	; print the numbers now
	move.w	(a7)+,d1
	addi.w	#charbord,d1
	moveq	#16,d0
	trap	#3		; set cursor position in ascii window
	move.b	d7,d1		; byte to print
	cmpi.b	#$1f,d1 	; determine how byte is to be printed..
	bhi.s	lab1		; ...for all unprintable chars
	moveq	#$2e,d1 	; if byte < $1f, print '.'
	bra.s	do_print
lab1	cmpi.b	#$bf,d1 	; if byte >$bf, print '.'
	bls.s	do_print
	moveq	#$2e,d1
do_print
	bsr.s	send_byte
	addq.w	#$01,d5 	; make sure we don't overshoot edges
	swap	d7		; now
	sub.w	d7,d5
	move.w	nr_rows(a4),d7
	rol.w	#4,d7
	addi.b	#$f,d7
	and.w	d7,d5		; new position
nct_out rts

; print number in hex
print_2_nbrs
	move.w	  d1,-(a7)
	lsr.b	#$04,d1
	bsr.s	print_number
	move.w	(a7)+,d1
; this is used to print a number
print_number
	andi.b	#$0f,d1 	; only one byte
	addi.b	#$30,d1 	; make into decimal number
	cmpi.b	#$39,d1 	; is it a number?
	bls.s	send_byte	    ; yes ->...
	addq.b	#$07,d1 	;
send_byte moveq #-$01,d3		;
	moveq	#$05,d0 	; send one byte
	trap	#$03
	rts

	end
