; Menu item action routines for WINED
; v. 1.12		2003 Jun 11 08:46:22
;  W. Lenerz 1994 - 2018

	section action

	include dev1_asm_wined_includes
	include DEV8_keys_wman
	include DEV8_keys_wwork
	include DEV8_keys_wstatus
	include DEV8_keys_qdos_io


	xdef	redraw		; redraw items
	xdef	act_esc 	; esc item action routine
	xdef	act_move		; move item action routine
	xdef	act_zzz 	; zzz item action routine
	xdef	mk_btn		; true make button routine
	xdef	chan		; 'con'
	xdef	act_wake		; wake item routine
	xdef	act_size		; size item routine

	xdef	act_f2
	xdef	act_f3
	xdef	act_f4
	xdef	act_sec
	xdef	act_drv
	xdef	act_off

	xdef	act_1
	xdef	print_it
;	 xref	 changewin	 ; in lib_chwin
	xref	set_posn	; wined_gu, sets file position
	xref	backsec 	; wined_gu, gets last sector
	xref	nextsec 	; wined_gu, gets next sector
	xref	rest_old
	xref	off_txt
	xref	transa1toa0	; transfers string from (a1) to (a0)
	xref	draw_app
	xref	draw_app2
	xref	do_butn 	; menu extension do button

	xref	btncol		; (.b) contains button colourways
	xref	tit_str 	; title string (in wdef)
	xref	read_error	; read error routine
	xref	get_secnbr	; opens menu, gets new sector
	xref	get_drv 	; get drive number (wined_getfile)
	xref	do_f4menu	; shows the f4 menu
	xref	str_srch	; string search (wined_search)
	xref	hex_srch	; does hex search (wined_search)
	xref	resume		; resumes search (wined_search)
	xref	set_cur 	; sets cursor (wined_apphit)
	xref	save_file	; saves sector to file (wined_savfile)
	xref	append		; appends sector to file  "      "
	xref	load_file	; loads sector from file (wined_loadfile)
	xref	mksecascii	; makes 'sector' item strings (wined_getsecnbr)
	xref	ltoahex 	; long into hex ascii (gu_ltoahex)
	xref	read_sec
	xref	do_drive	; tries to open drive (wined_getdrive)
	xref	editpart	; edit partition (wined_edpart)
	xref	qlpart		; slow search for ql partition (wined_qlpart)
	xref	set_undl	; sets underline in 1-8 item (wined_gu)
	xref	wintype 	; wintype

;-----------------------------------------------------------------------


; ACT_ESC:  routine called by esc item (quits job definitely)

act_esc moveq	#-1,d1
	moveq	#0,d3
	moveq	#5,d0
	trap	#1

;-----------------------------------------------------------------------
; ACT_MOVE: routine called when move window item clicked

act_move
	bset	#3,$15(a1)		; show move
	move.b	#1,it_move+$40(a1)
	jsr	wm.chwin(a5)		; do move
redraw	moveq	#0,d4
	moveq	#-1,d3
	jmp	wm.ldraw(a5)		; reset items & return

;---------------------------------------------------------------------------
; ACT_ZZZ: makes a button (sleep item)

act_zzz moveq	#btn_err,d0
	rts			; gets out of the rd.ptr loop

mk_btn	move.l	(a4),a1
	move.b	#1,$40+it_zzz(a1)
	jsr	wm.unset(a5)	; unset main window, this also puts
	lea	btnstat(a4),a1	; the channel id into a0
	move.w	#0,$40(a1)
	moveq	#2,d0
	trap	#2
	move.l	file_id(a4),a0
	moveq	#2,d0
	trap	#2
	lea	btncol,a1
	moveq	#0,d3
	move.b	(a1),d3
	moveq	#-1,d2
	lea	myname,a1
	jsr	do_butn 	; do button now through menus
	lea	chan,a0
	moveq	#1,d0
	moveq	#-1,d1
	moveq	#0,d3
	trap	#2		; open chan
	move.l	a0,8(a4)		; channel id
	lea	status(a4),a1
	move.l	$20(a1),d1
	sub.l	$24(a4),d1
	move.l	d1,$24(a4)
	move.l	$20(a1),d1
	jsr	wm.prpos(a5)	; pull down primary where it was before
	move.w	#-1,row(a4)	; show no file open
	jsr	wm.wdraw(a5)	; draw window w/o file information
	move.l	sector(a4),d1	; d1 = sector number
	bsr	do_drive		; try to open drive & position file
	move.l	d1,sector(a4)
	moveq	#0,d4
	jmp	wm.wdraw(a5)

chan	DC.W	3,'CON'
myname	DC.W	mn2-*-2
	DC.B	'WINED'
mn2
;---------------------------------------------------------------------
; ACT_DRV: get new drive

act_drv move.b	#1,it_drv+$40(a1)
	move.b	#1,it_off+$40(a1)	; reset offset, too
	jsr	get_drv 		; routine to get drive
	jsr	mk_off_it
	clr.l	d4			; don't set pointer
	bra.s	wake2

;---------------------------------------------------------------------
; ACT_WAKE: called when wake item called

act_wake
	move.b	#1,it_wake+$40(A1)
	moveq	#0,d4			; don't set pointer

; wake 2: this redraws the items, sets the win to the appsub win, clears it and
; redraws it (reading sector first)
wake2	movem.l d4,-(sp)
	bsr	redraw			; redraw items first
	movem.l (sp)+,d4
	moveq	#-1,d2			;
	moveq	#0,d1
	jsr	wm.swapp(a5)		; set window to appsub window
	moveq	#-1,d3
	moveq	#iow.clra,d0
	trap	#3			; clear window
	cmp.w	#filedit,type(a4)	; file editing?
	bne.s	no_cset 		; no->...
	divs	#$10,d4 		; divide offset into rows & columns
	swap	d4			; columns = x
	move.w	d4,d0
	mulu	#18,d0			; 3 chars per byte, 6 pixels per har
	add.w	#leftpix+6,d0		  ; offset from left edge
	move.w	d0,d1			; x position
	swap	d1
	swap	d4			; nbr of rows = y
	mulu	#10,d4
	add.w	#charbord,d4
	move.w	d4,d1
	moveq	#iop.sptr,d0		; set pointer pos
	moveq	#1,d2			; releative to hit area
	moveq	#-1,d3
	trap	#3			; now
no_cset
	jmp	draw_app		; redraw appsub window

;---------------------------------------------------------------------
; ACT_1: called to see other blocks
; a sector may be up to 2 k long (ED). The window may display 512 or 256
; bytes, we thus may have up to 8 "blocks" in a sector which the window
; may display.
; If this item is hit with the keystrokes 1-8 , the user wants to see
; the corresponding block displayed
; if the item is hit or done with the mouse, we display the next block
act_1	moveq	#0,d0
	move.b	#1,it_1+$40(a1) 	; reset item
	move.b	wsp_kstr(a1),d0 	; keystroke
	sub.w	#$31,d0 		; make into number
	blt.s	hit_do			; but item was hit/done
					; this now is the row to be displayed
	move.w	winsects(a4),d1 	; number of sections in window
	sub.w	d0,d1			; did we hit number that is too big?
	bmi	redraw			; yes, so return ->...
	bra.s	act1_com


hit_do	move.w	row(a4),d0		; current "row"
	addq.w	#1,d0			; new one we're looking for
	move.w	winsects(a4),d1 	; number of "sections" in window
	sub.w	d0,d1			; did we want number that is too big?
	bge.s	act1_com		; ...no
	moveq	#0,d0			; yes, reset to beginning
act1_com move.w  d0,row(a4)		 ; new block we are editing
	jsr	set_undl


; print_it: this redraws the items, sets the win to the appsub win, clears it
; and redraws it (w/o reading sector first)

print_it bsr	 redraw
reread	moveq	#-1,d2
	moveq	#0,d1
	jsr	$60(a5) 	; set window to appsub window
	moveq	#-1,d3
	moveq	#$20,d0
	trap	#3		; clear window
	jmp	draw_app2	; draw it and return


;---------------------------------------------------------------------
; ACT_F2: called when f2 item called	(next sector)

act_f2	move.b	#1,it_f2+$40(a1)
	jsr	nextsec
	bra.s	p_s2

;---------------------------------------------------------------------
; ACT_F3: called when F3 item called	(previous sector)

act_f3	move.b	#1,it_f3+$40(a1)
	jsr	backsec
p_s2	move.l	d1,sector(a4)
	move.w	#0,row(a4)		; start at beginning
p_s3	move.b	#1,it_sec+$40(a1)
	bsr	set_undl		; set underline
	bsr	read_sec		; read this sector
	bne.s	f2err
f2ok	bsr	mksecascii		; make sector number into ascii
	bra.s	print_it		; redraw items & window
f2err	bsr	read_error
	move.l	8(a4),a0
	jsr	rest_old
	move.l	d1,sector(a4)
	clr.l	d4			; don't set pointer
	bra	wake2

;---------------------------------------------------------------------
; ACT_SEC: called when sector item called   (get new sector)

act_sec move.b	#1,it_sec+$40(a1)	;
	jsr	get_secnbr		; get new sector number
	bne.s	actsecerr		; if error
	clr.w	row(a4) 		; show first half
	tst.b	d4			; any offset into block?
	beq	wake2			; .. no just draw wdw
	move.w	nr_rows(a4),d0		; nbr of rows
	addq.w	#1,d0			; true nbr of rows
	lsl.w	#4,d0			; nbr of bytes shown in wdw
	divs	d0,d4			; d4.h = remainder, .l = row to display
	move.w	d4,row(a4)
	clr.w	d4
	swap	d4			; cursor to set
	bra	wake2			; re-read sector etc...
actsecerr
	bsr	read_error		; show error
	bra	print_it		; reshow old content


;---------------------------------------------------------------------
; ACT_F4: called to see other menu

act_f4	move.b	#1,it_f4+$40(a1)
	bsr	do_f4menu
	bne	end_actf4	; this will return with (in d1):
				; 0 = case independent string search
				; 1 = case dependent string search
				; 2 = hex search
				; 3 = resume search
				; 4 = write sector back
				; 5 = save to file
				; 6 = append to file
				; 7 = load from file
				; 8 = edit a partition
				; 9 = slow ql search
	tst.w	d1		; is it case independent search?
	bne.s	not_indep	; no->...
	move.w	#-1,err(a4)	; signal case independent search
	bra.s	strings
not_indep
	subq.w	      #1,d1	      ; is it case dependent search?
	bne.s	notcase 	; no->...
	clr.w	err(a4) 	; signal case dependent search
strings bsr	str_srch
	bset	#1,d6		; simulate char field
	bra.s	srchcom
notcase subq.w	#1,d1		; is it hex search?
	bne.s	not_hex 	; no->...
	clr.w	err(a4) 	; signal case dependent search (!)
	bsr	hex_srch		; does hex search
	moveq	#1,d6		; simulate hex field, high nibble
; common routine for all searches
srchcom move.l	err(a4),d5	; result
	blt	end_actf4	; if lower: not found
	move.w	d6,res2(a4)
	move.l	8(a4),a0
	move.l	(a4),a1
	move.l	sector(a4),d1
	move.l	d1,d4
	tst.w	err(a4) 	; if upper word high:
	bgt	p_s3		; esc pressed, so just redraw
	bsr	set_cur 	; set the cursor
	move.l	sector(a4),d1
	bra	p_s3		; redraw

not_hex subq.w	#1,d1		; is it resume search?
	bne.s	not_res 	; no->...
	move.w	res1(a4),err(a4)	; set old search value
	bsr	resume		; resume search
	move.w	res2(a4),d6	; set old hex/ascii switch
	bra.s	srchcom

wrregs	reg	a0-a3

not_res subq.w	#1,d1		; is it write sector back?
	bne.s	not_write	; no->...

write	movem.l wrregs,-(a7)
	bsr	set_posn
	moveq	#-1,d3
	moveq	#0,d2
	move.w	endofile(a4),d2 ; possibly don't write a whole sector
	bne.s	write2
	move.w	seclen(a4),d2	; number of bytes to write
write2	lea	file_sp(a4),a1	; point to data now
	moveq	#7,d0
	trap	#3
	movem.l (a7)+,wrregs
	bra	redraw


not_write
	subq.w	#1,d1		; is it save sector?
	bne.s	not_save		; no ->...
save	bsr	save_file	; save file
	bra	redraw		; and redraw item

not_save
	subq.w	#1,d1		; is it append to existing file?
	bne.s	not_appnd	; no ->...
	bsr	append
	bra	redraw		; and redraw item

not_appnd
	subq.w	#1,d1		; is it sector load ?
	bne.s	not_load
	bsr	load_file
	bra	print_it

not_load
	subq.w	#1,d1		; is it edit a partition
	bne.s	not_edit		; no->...
edit	bsr	editpart		; show partitions
ed2	move.l	(a4),a1
	bra	p_s3

not_edit
	subq.w	#1,d1		; is it slow search for ql partition?
	bne.s	not_ql		; no ->...
	bsr	qlpart		; yes, so do it
	bra.s	ed2
not_ql
end_actf4
	move.l	8(a4),a0
	move.l	(a4),a1
	bra	redraw

;-----------------------------------------------------------------------
; ACT_SIZE: routine called when size item clicked

act_size
	move.b	#0,it_size+$40(a1)
	moveq	#ch_size,d0
	rts

;-----------------------------------------------------------------------
; act_off: routine called when offset item clicked


act_off move.b	#1,it_off+$40(a1)
	move.b	#1,it_sec+$40(a1)
	cmp.w	#winedit,type(a4)	; are we editing a hard disk?
	bne	redraw			; no, so no offset...
	lea	wintype,a1
	tst.b	(a1)			; what type of hard disk I/F ?
	bne	redraw			; no offset if not miracle/Atari
	move.l	(a4),a1
	move.l	partit(a4),d1
	beq.s	set_off
	add.l	sector(a4),d1
	move.l	d1,sector(a4)
	clr.l	partit(a4)
	bra.s	ao_com
set_off move.l	sector(a4),partit(a4)
	clr.l	sector(a4)
ao_com	jsr	mksecascii		; make new ascii for sector
	bsr.s	mk_off_it		; make new text for offset item
	bra.s	end_actf4

mkscregs reg	 a0-a2
mk_off_it
	movem.l mkscregs,-(a7)
	move.l	partit(a4),d1		; new partition number
	lea	secnb3(a4),a1		; point to place for string
	lea	off_txt,a0
mksecom jsr	ltoahex 		; transform into hex now
	move.w	(a1)+,d0		; length of string
	addq.w	#1,d0			; +1 for the '$'
	move.w	d0,(a0)+		; into place
	move.b	#'$',(a0)+		; the '$'
	subq.w	#2,d0			; for dbf and the '$'
trans	move.b	(a1)+,(a0)+
	dbf	d0,trans		; transfer string now
mksout	movem.l (a7)+,mkscregs
	moveq	#0,d0
	rts

	end
