; Load file for WINED
; v. 1.01
;  W. Lenerz 1994 - 2018


	section file

	xdef	load_file

	include dev1_asm_wined_includes


	xref	loadtit 	; title for window
	xref	do_ferr 	; does ferr menu extension (lib_menus)
	xref	colw		; colourways byte  (main)
	xref	do_fsel 	; does fsel menu extension (lib_menus)

;-------------------------------------------------------------------------
; save_file
; entry 			exit
; d0				0 or error
; d1				corr
; d2				corr
; d3				corr
  
; condition codes set on exit
;-------------------------------------------------------------------------
sfregs	reg	d4/a0-a3
load_file
	movem.l sfregs,-(a7)
bigloop moveq	#0,d1		; no max lines
	moveq	#0,d3
	lea	colw,a1
	move.b	(a1),d3
	swap	d3		; colour ways
	move.b	(a1),d3
	moveq	#0,d2		; position at top
	moveq	#0,d4		; no extension
	lea	fname_sp(a4),a1
	sub.l	a3,a3		; no default dir
	move.l	a1,a2		; default is return
	lea	loadtit,a0	; title
	jsr	do_fsel 	; do menu now
	bne.s	load_out		; if esc, just leave


again	moveq	#1,d3		; open old exlusive
op_file lea	fname_sp(a4),a0
	moveq	#-1,d1
	moveq	#1,d0
	trap	#2		; open file
	tst.l	d0
	bne.s	err_file
	moveq	#-1,d3
apsavcom
	moveq	#0,d2
	move.w	seclen(a4),d2	; number of bytes to load
	moveq	#3,d0
	lea	file_sp(a4),a1
	trap	#3		; load to file
	move.l	d0,-(a7)		; keep error
	moveq	#2,d0
	trap	#2		; close file
	move.l	(a7)+,d0
	beq.s	load_out
	bra.s	err_file
load_out
	movem.l (a7)+,sfregs
	tst.l	d0		; return with error
	rts

err_file
	move.l	d0,d1
	move.l	#winpos,d2
	move.l	#$ffff,d3
	swap	d3
	lea	colw,a1
	move.b	(a1),d3
	jsr	do_ferr
	tst.l	d0
	bne.s	load_out
	tst.w	d1
	ble.s	load_out
	cmp.b	#3,d1		; retry
	beq	bigloop
	cmp.b	#1,d1		; again
	beq.s	again
	moveq	#3,d3
	cmp.w	#2,d1
	beq.s	op_file 	; over write
	bra.s	load_out

	end
