; this does the searches for WINED
;
; v. 1.00
;
;  W. Lenerz 1994 - 2018

	section qlpart

	xdef	qlpart

	xref	warning 	; prints a warning, waits until keypress
				; (wined_filerr)
	xref	do_dorp 	; does 'dorp' menu extension (lib_menu)

	xref	cvtlong 	; converts long integer to ascii
				; (gu)
	xref	string_nf	; "string was not found"
	xref	err_read		; "read error"
	xref	srch		; "search for?"
	xref	esc_abt 	; "press esc to abort"
	xref	sectsrch		; "searching sector"
	xref	searching	;
	xref	what_str

	xref	hex
	xref	err_hex
	xref	colw		; colourways (wined_cfg)
	xref	read_sec		; reads one sector (wined_gu)

	include dev1_asm_wined_includes

; case_srch: case dependent string search string
; hex_srch : searches for hex string

dostrstk equ	 4

myregs	reg	a0/a6
srchregs reg	d4-d7/a0/a2-a4

notfnd	lea	string_nf,a1	; string was not found
	bsr	warning 	; general warning
restore move.l	(a7)+,sector(a4)	; restitue old current sector number
	bra.s	quit_cts
end_srch
	addq.l	#dostrstk,a7	; show the sector we were in
quit_cts
	movem.l (a7)+,myregs
	rts

; entry point for hex search
qlpart	movem.l myregs,-(a7)
	move.l	sector(a4),-(a7)	; keep current sector nbr
ok	lea	searching,a0
	lea	colw,a1
	moveq	#3,d3
	move.b	(a1),d3 	, colourway
	move.l	#winpos,d2	; position
	lea	esc_abt,a1	; description
	move.l	#$ffff0020,d1	; menu item ctrl & max length
	lea	do_srch1,a2
	move.l	a4,a6		; keep pointer to our space
	jsr	do_dorp 	; the action routine will:
				; put the following value at err(a4)
				; negative if search unsuccessful
				; 0 if string found or esc
	tst.w	btn(a4) 	; was string found?
	bne.s	notfnd		; no!
	bra.s	end_srch

do_srch1
	movem.l srchregs,-(a7)
	move.l	a6,a4		; a4 point to our space
	moveq	#$20,d0
	moveq	#-1,d3
	trap	#$03		; clear this window
	lea	sectsrch,a1
	move.w	(a1)+,d2
	moveq	#7,d0
	trap	#3		; print 'searching sector'
	move.l	#-1,sector(a4)
srch_lp move.l	sector(a4),d0	; sector number
	add.l	step(a4),d0
	move.l	d0,sector(a4)
	lea	secnb3(a4),a1	; space for ascii
	jsr	cvtlong 	; make into ascii
	bne.s	dontshow		; if problem, don't print it
	moveq	#0,d3
	move.l	a1,-(a7)
	moveq	#20,d1
	moveq	#$11,d0
	trap	#3		; set cursor
	move.l	(a7)+,a1
	move.w	(a1)+,d2
	moveq	#7,d0
	trap	#3		; write out ascii now
dontshow
	move.l	a0,-(a7)		; keep channel id
	bsr	read_sec		; read a sector
	movem.l (a7)+,a0
	bne.s	notfnd2 	; if end reached: show not found
	moveq	#0,d3
	moveq	#1,d0
	trap	#3
	cmpi.b	#esc,d1 	; esc ?
	beq.s	stop_srch	; yes, so stop search ->...

	move.w	#$1ff,d0		; counter
	lea	file_sp(a4),a1
	cmp.l	#'qlwa',(a1)
	bne.s	srch_lp

stop_srch
	move.w	#0,row(a4)	; new half
	move.w	#0,btn(a4)
	bra.s	srchexit
notfnd2 move.w	#-7,btn(a4)	: not found
srchexit
	sub.l	a1,a1		; no message
	moveq	#0,d0		; no error
	movem.l (a7)+,srchregs
	rts			; return

	end
