; this does the searches for WINED
;
; v. 1.05	1995 Sep 19 13:56:28
;
;  W. Lenerz 1994 - 2018

	section search

	xdef	hex_srch
	xdef	str_srch
	xdef	make_hex		: make into hex
	xdef	resume			; resume search

	xdef	gu_upper
	xdef	cv_uctab
 
	xref	warning 		; prints a warning, waits until keypress
					; (wined_filerr)
	xref	input_str		; get a string (wined_gu)
	xref	do_dorp 		; does 'dorp' menu extension (lib_menu)


	xref	make1to9		; makes hex digit (wined_gu)
	xref	cvtlong 		; converts long integer to ascii (gu)
	xref	string_nf		; "string was not found"
	xref	err_read		; "read error"
	xref	srch			; "search for?"
	xref	esc_abt 		; "press esc to abort"
	xref	sectsrch		; "searching sector"
	xref	searching		;
	xref	srchfl			; 'searching s t s'
	xref	what_str
	xref	nextsec 		; get file 'position' for next sector(wined_gu)
	xref	hex
	xref	err_hex
	xref	colw			; colourways (wined_cfg)
	xref	read_sec		; reads one sector (wined_gu)
	xref	set_undl		; sets underline in 1->8 item (wined_gu)


	include dev1_asm_wined_includes

; case_srch: case dependent string search string
; hex_srch : searches for hex string

dostrstk equ	 4

myregs	reg	a0/a6
srchregs reg	d4-d7/a0/a2-a4

notfnd	lea	string_nf,a1	; string was not found
	bsr	warning 	; general warning

restore move.l	(a7)+,sector(a4); restitue old current sector number
	lea	side(a4),a1
	move.l	btn(a4),(a1)+	;
	move.w	btn+4(a4),(a1)
	bra.s	quit_cts

end_srch
	addq.l	#dostrstk,a7	; show the sector we were in
quit_cts
	movem.l (a7)+,myregs
	rts

; entry point for resume
resume	movem.l myregs,-(a7)
	move.l	sector(a4),-(a7)
	lea	string_sp(a4),a1
	bra.s	srch_com

; entry point for hex search

hex_srch
	movem.l myregs,-(a7)
	move.l	sector(a4),-(a7)	; keep current sector nbr
hs	bsr	get_hex 		; no, get hex number to search for
	beq.s	srch_com		; ok? - yes, so go on
	lea	err_hex,a1
	bsr	warning
	bra.s	hs

; entry point for string search
str_srch
	movem.l myregs,-(a7)
	move.l	sector(a4),-(a7)	; keep current sector nbr
	lea	string_sp(a4),a1
	lea	what_str,a3
	lea	srch,a0
	bsr	input_str		; get string to search for
	bne.s	restore
srch_com
	tst.w	(a1)			; is there a string?
	bne.s	str_xist		: yes ->..
	bra.s	restore 		; if none, return

; a string exists, set up 'dorp' menu
str_xist
	lea	searching,a0		; title
	lea	colw,a1
	clr.l	d3
	move.b	(a1),d3 		, colourway
	move.l	#winpos,d2		; position
	lea	esc_abt,a1		; description
	move.l	#$ffff0020,d1		; menu item ctrl & max length
	lea	do_srch1,a2		; this is the actual search routine
	move.l	a4,a6			; keep pointer to our space
	jsr	do_dorp 		; the action routine will put ...
					; ... the following value at err(a4):
					; negative if search unsuccessful
					; 0 if string found
					; positive if esc pressed during search
	tst.w	err(a4) 		; was string found?
	blt	notfnd			; no!->...
	bra.s	end_srch		; yes ->...

; this is the search routine
do_srch1
	movem.l srchregs,-(a7)		; keep some regs
	move.l	a6,a4			; a4 point to our space
	lea	btn(a4),a1
	move.l	side(a4),(a1)+		; stock the old values somewhere
	move.w	fl_sect(a4),(a1)

	moveq	#$20,d0
	moveq	#0,d3			; continue searching when wdw buried
	trap	#$03			; clear this window
	cmp.w	#flodisk,type(a4)	; is it a floppy disk?
	beq.s	do_fl1			; yes->...
	lea	sectsrch,a1		; message string if win or file
	bra.s	do_comm
do_fl1	lea	srchfl,a1		; message string for floppy disks
do_comm move.w	(a1)+,d2
	moveq	#7,d0
	trap	#3			; print 'searching sector'
	move.w	err(a4),d7
	clr.l	err(a4)
	move.w	d7,res1(a4)
srch_lp jsr	nextsec 		; get next sector 'position'
	move.l	d1,sector(a4)		; new sector
	tst.l	d0			; upper word of d0 = -1 if we didn't
					; overshoot end of disk
	beq	notfnd2 		; we are at end of disk->...
	move.l	d1,d0			; d0 = next sector 'position'
	cmp.w	#flodisk,type(a4)	; is it a floppy?
	beq.s	do_fl2			; yes ->...
	lea	secnb3(a4),a1		; space for ascii
	jsr	cvtlong 		; make long sector position into ascii
	bne	dontshow		; if problem, don't print it
	moveq	#-1,d3
	move.l	a1,-(a7)
	moveq	#20,d1
	moveq	#$11,d0
	trap	#3			; set cursor
	move.l	(a7)+,a1
	move.w	(a1)+,d2
	moveq	#7,d0
	trap	#3			; write out ascii sector number now
	bra.s	dontshow
do_fl2	moveq	#0,d3			; write out sector, track and side...
	moveq	#13,d1
	moveq	#$11,d0
	trap	#3			; set cursor
	move.w	side(a4),d1
	add.b	#'0',d1
	moveq	#5,d0
	trap	#3			; write out ascii now

	moveq	#18,d1
	moveq	#$11,d0
	trap	#3			; set cursor
	move.w	track(a4),d1
	move.b	d1,d2
	lsr.b	#4,d1
	add.b	#'0',d1
	moveq	#5,d0
	trap	#3			; write out ascii now
	move.b	d2,d1
	andi.b	#$f,d1
	cmp.b	#9,d1
	ble.s	fl_ok1
	addq.b	#7,d1
fl_ok1	add.b	#'0',d1
	moveq	#5,d0
	trap	#3			; write out ascii now

	moveq	#27,d1
	moveq	#$11,d0
	trap	#3			; set cursor
	move.w	fl_sect(a4),d1
	move.b	d1,d2
	lsr.b	#4,d1
	add.b	#'0',d1
	moveq	#5,d0
	trap	#3			; write out ascii now
	move.b	d2,d1
	andi.b	#$f,d1
	cmp.b	#9,d1
	ble.s	fl_ok2
	addq.b	#7,d1
fl_ok2	add.b	#'0',d1
	moveq	#5,d0
	trap	#3			; write out ascii now
dontshow
	move.l	a0,-(a7)		; keep channel id
	bsr	read_sec		; read a sector
	movem.l (a7)+,a0		; get a0 back, use movem, doesn't change cond. codes
	bne	notfnd2 		; if end reached: show not found
	moveq	#0,d3			; now see whether user presses esc
	moveq	#1,d0
	trap	#3
	cmpi.b	#esc,d1 		; esc ?
	beq.s	stop_srch		; yes, so stop search ->...
	moveq	#0,d0			; leave this at all cost!
	move.w	seclen(a4),d0		; counter
	subq.w	#1,d0			; prepare for dbf
	lea	file_sp(a4),a3		; point to this sector
	lea	string_sp(a4),a1	; this is the string
	move.w	(a1)+,d4		; d4 = length of string
	moveq	#0,d5			; init
	move.b	(a1)+,d5		; first byte
	subq.w	#2,d4			; dbf & minus 1st byte
	tst.w	d7
	bne.s	no_case

; here code for case dependent search
srch_loop
	cmp.b	(a3)+,d5		; same ?
	bne.s	do_srch 		; no; so do dbf
	move.l	a3,-(a7)
	move.w	d4,d1
	blt.s	found_it
cmp_loop
	cmpm.b	(a3)+,(a1)+
	bne.s	not_it
	dbf	d1,cmp_loop

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
found_it
	addq.l	#4,a7			; get rid of a3
	move.l	#$ffff,d1		; prepare d1: upper word 0 (for divu)
	add.w	seclen(a4),d1
	sub.w	d0,d1
	cmp.w	#$1f,nr_rows(a4)	; is it large window?
	beq.s	big_win
	divu	#$100,d1
	bra.s	all_win
big_win divu	#$200,d1
all_win move.w	d1,row(a4)		; this is the display row
	clr.w	d1			; this shows that search was ok
	swap	d1
	move.l	d1,err(a4)		; show no error & cursor position
	jsr	set_undl		; set new underline for 1->8 item
	bra.s	srchexit

not_it	move.l	(a7)+,a3
	lea	string_sp+3(a4),a1	; point to string after first byte
do_srch dbf	d0,srch_loop
	bra	srch_lp

stop_srch
	move.w	#1,err(a4)
	bra.s	srchexit

notfnd2 move.w	#-7,err(a4)		: not found
srchexit
	sub.l	a1,a1			; no message
	moveq	#0,d0			; no error
	movem.l (a7)+,srchregs
	rts				; return

; now case independant search
no_case moveq	#0,d1
	move.b	cv_uctab(pc,d5.w),d5	; make into upper case
s_loop	move.b	(a3)+,d1
	move.b	cv_uctab(pc,d1.w),d1	; make into upper case
	cmp.b	d5,d1			; same ?
	bne.s	do_srch2		; no, so do dbf
	move.l	a3,-(a7)
	move.w	d4,d2
	blt.s	found_it
	moveq	#0,d3
c_loop	move.b	(a3)+,d1
	move.b	cv_uctab(pc,d1.w),d1	; make into upper case
	move.b	(a1)+,d3
	move.b	cv_uctab(pc,d3.w),d3	; make into upper case
	cmp.b	d3,d1
	bne.s	not_it2
	dbf	d2,c_loop
	bra	found_it
not_it2 move.l	(a7)+,a3
	lea	string_sp+3(a4),a1	; point to string after first byte
do_srch2
	dbf	d0,s_loop
	bra	srch_lp




; this translates a byte into its upper/lower case
; entry 			exit

; d1.b	bytes to translate		d1.w  new upper/lower cased bytes

gu_upper
	andi.w	#$00ff,d1
	move.b	cv_uctab(pc,d1.w),d1
	rts
cv_uctab
	DC.B	$00,$01,$02,$03,$04,$05,$06,$07,$08,$09
	DC.B	$0A,$0B,$0C,$0D,$0E,$0F,$10,$11,$12,$13,$14,$15,$16,$17
	DC.B	$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,' !"#$%&',$27,'()*+'
	DC.B	',-./0123456789:;<=>?@ABCD'
	DC.B	'EFGHIJKLMNOPQRSTUVWXYZ'
	DC.B	91,92,']'
	DC.B	'^_`ABCDEFGHIJKLMNOP'
	DC.B	'QRSTUVWXYZ{|}~',$A1,$A2,$A3,'',$A5
	DC.B	$A6,'',$A8,$A9,$AA,$AB,'AAAEEEIIIIOOOUUU',$9D,$9E,$9F
	DC.B	'',$81,$82,$83,'',$85,$86,'',$88,$89,$8A,$8B,$AC,$AD
	DC.B	$AE,$AF,$B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB
	DC.B	$BC,$BD,$BE,$BF,$C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9
	DC.B	$CA,$CB,$CC,$CD,$CE,$CF,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7
	DC.B	$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF,$E0,$E1,$E2,$E3,$E4,$E5
	DC.B	$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,$F0,$F1,$F2,$F3
	DC.B	$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF


;----------------------------------------------------------
; get_hex
; get several hex numbers, perhaps spaced by space
; returns equ if ok, else ne
;
;----------------------------------------------------------
get_hex lea	string_sp(a4),a6	; string space
	lea	more_sp(a4),a1	; new string & possible default
	clr.w	(a6)+		; no string yet
	lea	hex,a3		; prompt
	lea	srch,a0
	bsr	input_str	; get a string
	bne.s	endloop 	; if problem
	moveq	#0,d2		; length of result 'string'
	move.w	(a1)+,d4		; string length
	beq.s	endloop
hex_loop
	move.b	(a1)+,d1		; high nibble
	cmp.b	#' ',d1
	bne.s	no_space
	subq.w	#1,d4		; ignore spaces
	beq.s	end_ok
	bra.s	hex_loop
no_space
	bsr.s	make_hex
	bne.s	endloop
	subq.w	#1,d4
	beq.s	end_ok
	move.b	d1,d3
	lsl.w	#4,d3		; make into high nibble
	move.b	(a1)+,d1
	bsr.s	make_hex
	bne.s	endloop
	add.b	d1,d3		; add low nibble
	addq.w	#1,d2		; one more byte
	move.b	d3,(a6)+
	subq.w	#1,d4
	beq.s	end_ok
	bra.s	hex_loop

end_ok	lea	string_sp(a4),a1
	move.w	d2,(a1)
	moveq	#0,d0
endloop rts


;------------------------------
;
; test whether d1 is a hex number and make it into true nibble
; returns d0 = 0 if ok, else d0 = -15
;
;-------------------------------

make_hex
	bsr	gu_upper		; make into upper case
	cmpi.b	#'0',d1
	blt.s	thex_err
	cmpi.b	#'9',d1 	; is it 0 to 9?
	ble.s	hex_chif		; yes ->...
	cmpi.b	#'A',d1
	blt.s	thex_err
	cmpi.b	#'F',d1
	bgt.s	thex_err		; must be a to f, else error
hex_let sub.b	#$37,d1
	moveq	#0,d0
	rts

hex_chif
	sub.b	#'0',d1
	moveq	#0,d0
	rts

thex_err
	moveq	#-15,d0 	 ; this returns with error bad param
	rts


	end
