; init for wined
; v. 1.07		2003 Jun 11 07:37:24
;  W. Lenerz 1994 - 2018

	section start

	include dev8_keys_wman
	include dev8_keys_wwork
	include dev1_asm_wined_includes
	include DEV8_keys_wstatus

	xref.l	version

	xref	windef
	xref	optsdef
	xref	mu_getdef	; get menu col defaults (lib_get_menu_defcols)
	xref	act_esc
	xref	cross
	xref	colw		; byte with main wdw colourway
	xref	btncol		; byte with button colourway
	xref	make_col
	xref	make_col3
	xref	chk_col
	xref	mk_btn
	xref	abort
	xref	errmess
	xref	get_drv 	; (wined_getdrive)
	xref	chan
	xref	draw_app	; appsub window drawing routine
	xref	hrep
	xref	appl1
	xref	wtype
	xref	flptype 	; type of floppy (dd or hd) (wined_cfg)
	xref	dvnbr
	xref	set_drive	; sets drive items (wined_rdrwinfo)
	xref	deftrak 	; default floppy tracks (wined_cfg)
	xref	defside 	; default floppy sides( (wined_cfg)
	xref	nosel
	xref	rdrwinfo		; redraws title & drive item (wined_rdrwinfo)
	xref	mksecascii	; redraws sector item
	xref	set_blocks	; sets nbr of blocks in wdw (wined_gu)
	xref	defmcol 	; use menu default colwyas?(wined_cfg)
	xref	do_sysspr
	xdef	abtxt

appy	equ	160
ysize	equ	212+4+6+appy


debut	bra.s	start
	dc.l	'W.L.'
	dc.w	$4afb
abtxt	dc.w	name2-*-2
	dc.b	'Wined'
name2
	dc.l	 version
	dc.w	'Program & documentation  W. Lenerz 1994-2018'
	dc.w	' Todos derechos reservados en todos paises'



; a0 contains channel id
; a4 contains pointer to working definition & reserved space
; a5 contains window manager vector


start	move.l	a6,a0			; a0= end of code
	add.l	a4,a0			; a0= start of dataspace
	move.l	a7,a1
	subq.l	#4,a1
	moveq	#0,d0
init_lp5
	move.l	d0,(a0)+		; clear our dataspace
	cmp.l	a0,a1
	bgt.s	init_lp5
	move.l	a4,a5			; point to end of dataspace
	moveq	#-1,d1
	moveq	#-1,d2
	moveq	#$10,d0
	trap	#1			; read mode
	move.b	d1,d7			; keep mode
	cmp.b	#8,d1
	blt.s	initlb1
	moveq	#0,d1
	move.b	#4,d7
	moveq	#$10,d0
	trap	#1			; set mode to 4 if > 4
initlb1 move.l	a5,a4
	add.l	a6,a4			; a4= points to dataspace now
	lea	chan,a0
	moveq	#1,d0
	moveq	#-1,d1
	moveq	#0,d3
	trap	#2
	tst.w	d0			; open window #1
	bne	act_esc
	move.l	a0,a6			; a6=channel id
	moveq	#$70,d0
	moveq	#-1,d3
	trap	#3			; is pi there?
	tst.w	d0
	bne	nowman			; no!
	move.l	a1,d0			; is wm there?
	beq	nowman			; ... no!
	move.l	a1,a5			; a5= pe vector
	move.l	(a1),wman(a4)
	subq.l	#8,a7
	moveq	#0,d2
	move.l	a7,a1
	moveq	#$6c,d0
	trap	#3			; find window limits
	move.w	2(a1),d5		; max y size
	addq.l	#8,a7
; now fill in colours - first check colourways (& fill in if menu defaults)
	lea	defmcol,a1
	tst.b	(a1)			; use menu default?
	beq.s	no_mdefs		; ...no
	moveq	#-1,d0
	lea	colw,a1 		; colourway for main wdw
	move.b	d0,(a1) 		;
	lea	btncol,a1
	move.b	d0,(a1) 		;
no_mdefs
	lea	colw,a1 		; colourway for main wdw
	moveq	#0,d0			; param is main wdw
	bsr	chk_col 		; check if colourway is possible
	bne	act_esc 		; oops!
	lea	btncol,a1
	moveq	#2,d0
	bsr	chk_col 		; check if colourway is possible
	bne	act_esc 		; oops!
do_cols
	moveq	#1,d4			; first info win is title bar
	lea	colw,a1
	lea	windef,a3
	move.l	wman(a4),d1
	bsr	make_col		; get & make  colours
	lea	optsdef,a3
	bsr	make_col
	bne	act_esc
	bsr	do_sysspr		; possibly replace sprites with syssprite
	lea	status(a4),a1
	move.w	#-1,dontread(a4)
	moveq	#0,d4
	move.b	#wsi.unav,d4
	swap	d4
	move.b	#wsi.avbl,d4		; d4 = unav | available
	sub.w	#ysize,d5		; what is size of our window?
	blt.s	toosmall		; a small window->...
	move.w	#$1f,nr_rows(a4)	; here long, (32 rows)
	lea	windef+2,a3		; point to window  defn, y size
	move.w	(a3),d0 		; y size into d0
	add.w	#appy,d0		; add bigger window size
	move.w	d0,(a3) 		; and fill in
	lea	hrep+2,a3		; point to repeated windefs
	move.w	d0,(a3) 		; fill in new window size
	lea	appl1+2,a3		; point to app sub defn
	move.w	(a3),d0 		; get app sub y size
	add.w	#appy,d0		; add bigger size
	move.w	d0,(a3) 		; and fill in
	swap	d4			; reset this
	bra.s	initcom
toosmall				; used for small window
	move.w	#$f,nr_rows(a4) ; number of rows if small window

initcom moveq	#0,d1
	lea	windef,a3
	jsr	4(a5)			; set up window
	move.b	d4,it_1+$40(a1) 	; this is unav or av according to size
	swap	d4
	move.b	d4,it_size+$40(a1)	; same here
	lea	colw,a1
	move.l	a4,a3
	move.l	$70(a3),a3
	move.l	(a3),a3
	moveq	#0,d0
	jsr	make_col3		; make appsub colours now
	move.w	d0,paper(a4)
	move.w	d2,ink(a4)
	jsr	$c(a5)			; draw managed window

; set up default sector length
	move.w	#512,seclen(a4) 	; sector length
; set up the default drive number (1 to 8)
	lea	dvnbr,a1		; default drive number in config block
	move.b	(a1),d0
	move.w	d0,drive(a4)		; copy into othis job's default now
; set up the type of device to edit (1=win, 2=floppy, 3=file)
	lea	wtype,a1		; type of editing: 1 =win, 3=floppy...
	moveq	#0,d0			; ... in config block
	move.b	(a1),d0
	move.w	d0,type(a4)		; now set it for this job

; set up defaults for floppies
	lea	flptype,a1		; what type of floppy: 0= dd, 1= hd 2=ed
	move.b	(a1),d0
	lea	btnstat+$42(a4),a1	; point to ed item
	move.w	d0,ftype(a4)		; type of floppy into our area
	moveq	#2,d2
	sub.w	d0,d2
	move.b	#$80,(a1,d2.w)		; set ed, hd or dd item to selected

	lea	deftrak,a1
	move.b	(a1),d0
	lea	btnstat+$47(a4),a1
	cmp.b	#39,d0
	bne.s	t80
	move.b	#$80,(a1)
	bra.s	sides
t80	move.b	#$80,1(a1)	; set sides itme
sides	lea	defside,a1
	move.b	(a1),d0
	lea	btnstat+$45(a4),a1
	beq.s	single		; this is = if the move.b was 0
	move.b	#$80,1(a1)
	bra.s	all_dvces
single	move.b	#$80,(a1)

; now set the drive in 'drive' item and set up special file
all_dvces jsr	set_drive
; set whether we should open drive request window every time
	lea	nosel,a1		; do not open drive request window
	move.b	(a1),d0
	move.w	d0,nsel(a4)

; we also come to the following label from change size:
draw_all
	move.l	ww_plitm(a4),a3 	; point to items list
	moveq	#it_sec,d0
	mulu	#wwl.elen,d0		; offset to item for sector
	lea	secnb(a4),a2		; this points to nothing yet, empty string
	move.l	a2,$c(a3,d0.w)		; item content: empty string

	moveq	#it_drv,d0		; now for "drive" item
	mulu	#wwl.elen,d0
	lea	drivetxt(a4),a2
	move.l	a2,$c(a3,d0.w)		; place for content
	move.w	dontread(a4),-(a7)
do_draw jsr	wm.wdraw(a5)		; draw window contents(w/o appsub win)
	move.w	(sp)+,d0
	cmp.w	#1,d0			; did we come here from change size?
	bne.s	firsttime		; no
	jsr	rdrwinfo		; yes, so redraw items
	bra.s	rdptr			; and read pointer

firsttime
	jsr	get_drv 		; get drive specifics now (this sets row
	move.w	#0,dontread(a4) 	; to 0)
ddr2	jsr	$1c(a5) 		; draw window contents(with appsub win)

rdptr	move.l	(a4),a1
	jsr	$30(a5) 		; read ptr

is_com	tst.l	d0
	beq.s	rdptr
	cmp.w	#btn_err,d0
	bne.s	ch_size2
button	bsr	mk_btn
	bra.s	rdptr
ch_size2
	cmp.l	#ch_size,d0		; here we change size
	bne	bad			; err, no we don't
	move.w	nr_rows(a4),d0		; how many rows in window?
	cmp.w	#$f,d0			; is it big window?
	beq.s	mk_big			; ... no, so make it big now->
	move.w	#$f,nr_rows(a4) 	; now make small wdw: nbr of rows
	lea	windef+2,a1		; window defn
	move.w	(a1),d0
	sub.w	#appy,d0
	move.w	d0,(a1) 		; new y size
	lea	hrep+2,a1
	move.w	d0,(a1) 		; also in repeated part of win defn
	lea	appl1+2,a1
	move.w	(a1),d0 		; appsub window size
	sub.w	#appy,d0		;
	move.w	d0,(a1) 		; new size now
	move.w	row(a4),d0
	lsl.w	#1,d0
	move.w	d0,row(a4)		; new block number
	bra.s	chcom
mk_big	move.w	#$1f,nr_rows(a4)	; new number of rows
	lea	windef+2,a1	;
	move.w	(a1),d0
	add.w	#appy,d0
	move.w	d0,(a1) 		; new window size
	lea	hrep+2,a1
	move.w	d0,(a1) 		; also in repeated part
	lea	appl1+2,a1
	move.w	(a1),d0
	add.w	#appy,d0
	move.w	d0,(a1) 		; new appsub y size
	move.w	row(a4),d0
	lsr.w	#1,d0
	move.w	d0,row(a4)		; new block number
chcom	jsr	wm.unset(a5)		; unset window
	lea	windef,a3
	lea	status(a4),a1
	move.w	#1,dontread(a4) 	; show no_draw
	jsr	wm.setup(a5)		; set new window
	jsr	set_blocks		; set blocks now
	tst.w	winsects(a4)		; if 0 sections, no need to have 1-8
	bne.s	no_set			;
	move.b	#wsi.unav+1,it_1+$40(a1) ; set this item to unavailable now
	bra.s	okk
no_set	move.b	#1,it_1+$40(a1) 	; set this item to available now
okk	lea	colw,a1
	move.l	ww_pappl(a4),a3
	move.l	(a3),a3
	moveq	#0,d0
	jsr	make_col3		; make appsub colours now
	jsr	wm.prpos(a5)		; draw managed window
	bra	draw_all

bad	move.l	d0,-(a7)
	jsr	$14(a5)
	moveq	#-1,d3
	moveq	#$20,d0
	trap	#3
	lea	abort,a1
	move.w	(a1)+,d2
	moveq	#7,d0
	trap	#3
	move.l	(a7)+,d0
	move.w	$cc,a2
	jsr	(a2)
	moveq	#1,d0
	trap	#3
	bra	act_esc

nowman	lea	errmess,a1
print_out
	move.w	(a1)+,d2
	moveq	#-1,d3
	moveq	#7,d0
	trap	#3
	bra	act_esc

	end
